import request from '@/utils/request';
import type { ApiResult } from '@/api';
import type { Company, CompanyParam } from './model';
import { PageResult } from '@/api';

/**
 * 查询企业资料
 */
export async function getCompany(params?: CompanyParam) {
  const res = await request.get<ApiResult<Company>>('/system/company/profile', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询Company列表
 */
export async function pageCompany(params: CompanyParam) {
  const res = await request.get<ApiResult<PageResult<Company>>>(
    '/system/company/page',
    { params }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加Company
 */
export async function addCompany(data: Company) {
  const res = await request.post<ApiResult<unknown>>('/system/company', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改Company
 */
export async function updateCompany(data: Company) {
  const res = await request.put<ApiResult<unknown>>('/system/company', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除Company
 */
export async function removeCompany(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/system/company/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除Company
 */
export async function removeBatchCompany(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/system/company/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
